CREATE OR REPLACE
PROCEDURE NOTAFISCAL_NFE_PAULISTANA(
   P_NRLISTA     IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_CDEMPRESA   IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_DTINICIAL   IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_DTFINAL     IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_NRSEQARQMAG IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_LIVROMAG    IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_CDINSCMUNI  IN NOTAFISCAL.CDINSCMUNI%TYPE,
   P_VERSAO      IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_TPRPS       IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_SIMPLES     IN NOTAFISCAL.NRLANCTONF%TYPE)
AS
   V_EMPRESA       VARCHAR2(4000);
   V_DADOS         VARCHAR2(4000);
   V_DADOS_9       VARCHAR2(4000);
   V_ISS           VARCHAR2(02);
   V_CONTADOR      NUMBER;
   V_CONT_REG_2    NUMBER;
   V_VRDEDUCAO     NUMBER;
   V_VRTOTAL       NUMBER;
   V_VRTOTDEDUCAO  NUMBER;
   V_VRTOTISS      NUMBER;
   V_VRTOTCRED     NUMBER;
   V_INSSRET       VARCHAR2(02);
   V_PISRETE       VARCHAR2(02);
   V_PISRETS       VARCHAR2(02);
   V_COFINSRETE    VARCHAR2(02);
   V_COFINSRETS    VARCHAR2(02);
   V_CSLLRETE      VARCHAR2(02);
   V_CSLLRETS      VARCHAR2(02);
   V_IRRFRETE      VARCHAR2(02);
   V_IRRFRETS      VARCHAR2(02);
BEGIN
   /* sequencial para gerao da nota fiscal paulista */
   V_CONTADOR      := 0000000000;
   V_CONT_REG_2    := 0;
   V_VRDEDUCAO     := 0;
   V_VRTOTAL       := 0;
   V_VRTOTDEDUCAO  := 0;
   V_VRTOTISS      := 0;
   V_VRTOTCRED     := 0;
   V_ISS           := '31'; /*Cdigo do Grupo do ISS*/
   V_INSSRET       := '40';
   V_PISRETE       := '55'; /*PIS RETIDO ENTRADA*/
   V_PISRETS       := '56'; /*PIS RETIDO SAIDA*/
   V_COFINSRETE    := '65'; /*COFINS RETIDO ENTRADA*/
   V_COFINSRETS    := '66'; /*COFINS RETIDO SAIDA*/
   V_CSLLRETE      := '80'; /*CSLL RETIDO ENTRADA*/
   V_CSLLRETS      := '70'; /*CSLL RETIDO SAIDA*/
   V_IRRFRETE      := '21'; /*IRRF RETIDO ENTRADA*/
   V_IRRFRETS      := '22'; /*IRRF RETIDO SAIDA*/

   /* TIPO 1 */
   V_EMPRESA :=  '1'||
                 P_VERSAO||
                 REPLACE(REPLACE(REPLACE(P_CDINSCMUNI,'-',''),'.',''),'/','')||
                 TO_CHAR(P_DTINICIAL, 'yyyymmdd')||
                 TO_CHAR(P_DTFINAL, 'yyyymmdd');
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('1'||LPAD(V_CONTADOR,9,'0'), V_EMPRESA, P_NRSEQARQMAG);
   V_CONTADOR := NVL(V_CONTADOR,0)+1;
   IF P_VERSAO = '001' THEN
      /* TIPO 2 */
      FOR C_NOTAS IN (SELECT '2'||
                             REPLACE(P_TPRPS,'-',' ')||
                             SUBSTR(RPAD(NVL(DECODE(IDENTRSAIDOP, 'S', CDSERIE, CDSERIEENTR),' '), 5, ' '),1,5)|| /* campo 3 */
                             SUBSTR(LPAD(NVL(NRNOTAFISC,'0'), 12, '0'),1,12)|| /* numero do rps */
                             TO_CHAR(DTEMISSAO, 'yyyymmdd')|| /* data de emissao do rps */
                             DECODE(IDSTATUS, 'C', 'C', 'T')|| /* situacao do rps */
                             SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15) AS DSINICIO,
                             LPAD(NVL(SUBSTR(CLASSE_CODTRIBPROD(CDARVPROD,P_CDEMPRESA,P_CDINSCMUNI,'SERV'),1,5),'0'),5,'0')||/* codigo do servico prestado na nf */
                             SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRALIQUOTA,2), '00.00')), '.', ''),'0'),4,'0'),1,4)|| /* valor da aliquota campo 10 */
                             '2'|| /* ISS RETIDO  campo 11 */
                             DECODE(IDTPJURTOMA, 'F', '1','2')||
                             SUBSTR(RPAD(REPLACE(REPLACE(REPLACE(NRINSJURTOMA,'.',''),'/',''),'-',''),14,' '),1,14)|| /* campo 13 */
                             SUBSTR(LPAD(REPLACE(REPLACE(REPLACE(NRINSMUNTOMA,'/',''),'-',''),'.',''),8,'0'),1,8)|| /* inscricao municipal do tomador (fornecedor) campo 14 */
                             SUBSTR(LPAD(NVL(REPLACE(REPLACE(REPLACE(NRINSESTTOMA,'/',''),'.',''),'-',''), '0'), 12,'0'),1,12)|| /* inscricao estadual do tomador */
                             UPPER(RPAD(NVL(SUBSTR(NRRAZSOCTOMA, 1,75), ' '), 75,' '))|| /* campo 16 */
                             LPAD(' ', 3,' ')|| /* tipo de endereco do tomador */
                             UPPER(RPAD(NVL(SUBSTR(DSENDETOMA, 1,50), ' '), 50,' '))||
                             LPAD(' ', 10,' ')|| /* numero do endereco do tomador */
                             UPPER(RPAD(NVL(SUBSTR(DSCOMPLTOMA, 1,30), ' '), 30,' '))||
                             UPPER(RPAD(NVL(SUBSTR(NMBAIRTOMA, 1,30), ' '), 30,' '))||
                             UPPER(RPAD(NVL(SUBSTR(NMMUNICIPIO,1,50), ' '), 50,' '))|| /* cidade do tomador */
                             RPAD(NVL(SGESTADO, ' '), 2,' ')||  /* uf do tomador */
                             SUBSTR(LPAD(NVL(SUBSTR(REPLACE(REPLACE(NRCEPTOMA,'.',''),'-',''),1,8), '0'), 8,'0'),1,8)||
                             SUBSTR(UPPER(RPAD(NVL(DSEMAILTOMA, ' '), 75,' ')),1,75)||
                             SUBSTR(UPPER(SUBSTR(DSPRODEMIS,1,LENGTH(DSPRODEMIS))),1,1000) AS DSFINAL,
                             NF.CDFILIAL, NF.NRLANCTONF, NF.VRNOTAFISC, SUM(NF.VRTOTISS) AS VRTOTISS, SUM(NF.VRTOTCRED) AS VRTOTCRED, NF.NRNOTAFISC
                      FROM (/* FORNECEDOR */
                            SELECT N.CDEMPRESA, N.CDINSCMUNI, N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC, N.NRNOTAFISC, IP.CDPRODUTO,
                                   N.IDENTRSAIDOP, N.CDSERIE, N.CDSERIEENTR, N.DTEMISSAO, N.IDSTATUS, P.CDARVPROD,
                                   VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL,N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'A') AS VRALIQUOTA,
                                   F.IDTPIJURFORN AS IDTPJURTOMA, N.NRINSJURNF AS NRINSJURTOMA, F.NRINSMUNFORN AS NRINSMUNTOMA,
                                   F.NRINSESTFORN AS NRINSESTTOMA, F.NMRAZSOCFORN AS NRRAZSOCTOMA, E.DSENDEFORN AS DSENDETOMA,
                                   E.DSCOMPENDFOR AS DSCOMPLTOMA, E.NMBAIRFORN AS NMBAIRTOMA, M.NMMUNICIPIO, E.SGESTADO,
                                   E.NRCEPFORN AS NRCEPTOMA, E.DSEMAILFORN AS DSEMAILTOMA, IP.DSPRODEMIS, M.CDMUNICIPIO,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'C'),0) AS VRTOTISS,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'I'),0) AS VRTOTCRED
                              FROM NOTAFISCAL N, FORNECEDOR F, ENDEFORN E, MUNICIPIO M, LISTA L, ITEMPRODUTO IP, PRODUTO P
                             WHERE L.NRLISTA = P_NRLISTA
                               AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                               AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                               AND N.CDFILIAL = IP.CDFILIAL
                               AND N.NRLANCTONF = IP.NRLANCTONF
                               AND N.IDORIGDESTNF = 'F'
                               AND N.CDFORNECED = F.CDFORNECED
                               AND F.CDFORNECED = E.CDFORNECED
                               AND E.IDTPENDEFORN = 'P'
                               AND E.CDPAIS = M.CDPAIS
                               AND E.SGESTADO = M.SGESTADO
                               AND E.CDMUNICIPIO = M.CDMUNICIPIO
                               AND IP.CDPRODUTO  = P.CDPRODUTO
                            /* CLIENTE */
                            UNION ALL
                            SELECT N.CDEMPRESA, N.CDINSCMUNI, N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC, N.NRNOTAFISC, IP.CDPRODUTO,
                                   N.IDENTRSAIDOP, N.CDSERIE, N.CDSERIEENTR, N.DTEMISSAO, N.IDSTATUS, P.CDARVPROD,
                                   VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL,N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'A') AS VRALIQUOTA,
                                   C.IDTPIJURCLIE AS IDTPJURTOMA, N.NRINSJURNF AS NRINSJURTOMA, C.NRINSMUNICLIE AS NRINSMUNTOMA,
                                   C.NRINSESTCLIE AS NRINSESTTOMA, C.NMRAZSOCCLIE AS NRRAZSOCTOMA, E.DSENDECLIE AS DSENDETOMA,
                                   E.DSCOMPENDCLI AS DSCOMPLTOMA, E.NMBAIRCLIE AS NMBAIRTOMA, M.NMMUNICIPIO, E.SGESTADO,
                                   E.NRCEPCLIE AS NRCEPTOMA, E.DSEMAILCLIE AS DSEMAILTOMA, IP.DSPRODEMIS, M.CDMUNICIPIO,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'C'),0) AS VRTOTISS,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'I'),0) AS VRTOTCRED
                              FROM NOTAFISCAL N, CLIENTE C, ENDECLIE E, MUNICIPIO M, LISTA L, ITEMPRODUTO IP, PRODUTO P
                             WHERE L.NRLISTA = P_NRLISTA
                               AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                               AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                               AND N.CDFILIAL = IP.CDFILIAL
                               AND N.NRLANCTONF = IP.NRLANCTONF
                               AND N.IDORIGDESTNF = 'C'
                               AND N.CDCLIENTE = C.CDCLIENTE
                               AND C.CDCLIENTE = E.CDCLIENTE
                               AND E.IDTPENDECLIE = 'P'
                               AND E.CDPAIS = M.CDPAIS
                               AND E.SGESTADO = M.SGESTADO
                               AND E.CDMUNICIPIO = M.CDMUNICIPIO
                               AND IP.CDPRODUTO = P.CDPRODUTO
                            /* FILIAL */
                            UNION ALL
                            SELECT N.CDEMPRESA, N.CDINSCMUNI, N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC, N.NRNOTAFISC, IP.CDPRODUTO,
                                   N.IDENTRSAIDOP, N.CDSERIE, N.CDSERIEENTR, N.DTEMISSAO, N.IDSTATUS, P.CDARVPROD,
                                   VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL,N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'A') AS VRALIQUOTA,
                                   F.IDTPIJURFILI AS IDTPJURTOMA, N.NRINSJURNF AS NRINSJURTOMA, F.CDINSCMUNI AS NRINSMUNTOMA,
                                   F.CDINSCESTA AS NRINSESTTOMA, F.NMRAZSOCFILI AS NRRAZSOCTOMA, E.DSENDEFILI AS DSENDETOMA,
                                   E.DSCOMPENDFIL AS DSCOMPLTOMA, E.NMBAIRFILI AS NMBAIRTOMA, M.NMMUNICIPIO, E.SGESTADO,
                                   E.NRCEPFILI AS NRCEPTOMA, E.DSEMAILFILI AS DSEMAILTOMA, IP.DSPRODEMIS, M.CDMUNICIPIO,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'C'),0) AS VRTOTISS,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'I'),0) AS VRTOTCRED
                              FROM NOTAFISCAL N, FILIAL F, ENDEFILI E, MUNICIPIO M, LISTA L, ITEMPRODUTO IP, PRODUTO P
                             WHERE L.NRLISTA = P_NRLISTA
                               AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                               AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                               AND N.CDFILIAL = IP.CDFILIAL
                               AND N.NRLANCTONF = IP.NRLANCTONF
                               AND N.IDENTRSAIDOP = 'E'
                               AND N.IDORIGDESTNF = 'L'
                               AND N.CDFILIRECE = F.CDFILIAL
                               AND F.CDFILIAL = E.CDFILIAL
                               AND E.IDTPENDEFILI = 'P'
                               AND E.CDPAIS = M.CDPAIS
                               AND E.SGESTADO = M.SGESTADO
                               AND E.CDMUNICIPIO = M.CDMUNICIPIO
                               AND IP.CDPRODUTO = P.CDPRODUTO
                            UNION ALL
                            SELECT N.CDEMPRESA, N.CDINSCMUNI, N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC, N.NRNOTAFISC, IP.CDPRODUTO,
                                   N.IDENTRSAIDOP, N.CDSERIE, N.CDSERIEENTR, N.DTEMISSAO, N.IDSTATUS, P.CDARVPROD,
                                   VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL,N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'A') AS VRALIQUOTA,
                                   F.IDTPIJURFILI AS IDTPJURTOMA, N.NRINSJURNF AS NRINSJURTOMA, F.CDINSCMUNI AS NRINSMUNTOMA,
                                   F.CDINSCESTA AS NRINSESTTOMA, F.NMRAZSOCFILI AS NRRAZSOCTOMA, E.DSENDEFILI AS DSENDETOMA,
                                   E.DSCOMPENDFIL AS DSCOMPLTOMA, E.NMBAIRFILI AS NMBAIRTOMA, M.NMMUNICIPIO, E.SGESTADO,
                                   E.NRCEPFILI AS NRCEPTOMA, E.DSEMAILFILI AS DSEMAILTOMA, IP.DSPRODEMIS, M.CDMUNICIPIO,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'C'),0) AS VRTOTISS,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'I'),0) AS VRTOTCRED
                              FROM NOTAFISCAL N, FILIAL F, ENDEFILI E, MUNICIPIO M, LISTA L, ITEMPRODUTO IP, PRODUTO P
                             WHERE L.NRLISTA = P_NRLISTA
                               AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                               AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                               AND N.CDFILIAL = IP.CDFILIAL
                               AND N.NRLANCTONF = IP.NRLANCTONF
                               AND N.IDENTRSAIDOP = 'S'
                               AND N.IDORIGDESTNF = 'L'
                               AND N.CDFILIEMIT = F.CDFILIAL
                               AND F.CDFILIAL = E.CDFILIAL
                               AND E.IDTPENDEFILI = 'P'
                               AND E.CDPAIS = M.CDPAIS
                               AND E.SGESTADO = M.SGESTADO
                               AND E.CDMUNICIPIO = M.CDMUNICIPIO
                               AND IP.CDPRODUTO  = P.CDPRODUTO) NF
                      GROUP BY '2',
                               REPLACE(P_TPRPS,'-',' '),
                               SUBSTR(RPAD(NVL(DECODE(IDENTRSAIDOP, 'S', CDSERIE, CDSERIEENTR),' '), 5, ' '),1,5),
                               SUBSTR(LPAD(NVL(NRNOTAFISC,'0'), 12, '0'),1,12),
                               TO_CHAR(DTEMISSAO, 'yyyymmdd'),
                               DECODE(IDSTATUS, 'C', 'C', 'T'),
                               SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15),
                               LPAD(NVL(SUBSTR(CLASSE_CODTRIBPROD(CDARVPROD,P_CDEMPRESA,P_CDINSCMUNI,'SERV'),1,5),'0'),5,'0'),
                               SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRALIQUOTA,2), '00.00')), '.', ''),'0'),4,'0'),1,4),
                               '2',
                               DECODE(IDTPJURTOMA, 'F', '1','2'),
                               SUBSTR(RPAD(REPLACE(REPLACE(REPLACE(NRINSJURTOMA,'.',''),'/',''),'-',''),14,' '),1,14),
                               SUBSTR(LPAD(REPLACE(REPLACE(REPLACE(NRINSMUNTOMA,'/',''),'-',''),'.',''),8,'0'),1,8),
                               SUBSTR(LPAD(NVL(REPLACE(REPLACE(REPLACE(NRINSESTTOMA,'/',''),'.',''),'-',''), '0'), 12,'0'),1,12),
                               UPPER(RPAD(NVL(SUBSTR(NRRAZSOCTOMA, 1,75), ' '), 75,' ')),
                               LPAD(' ', 3,' '),
                               UPPER(RPAD(NVL(SUBSTR(DSENDETOMA, 1,50), ' '), 50,' ')),
                               LPAD(' ', 10,' '),
                               UPPER(RPAD(NVL(SUBSTR(DSCOMPLTOMA, 1,30), ' '), 30,' ')),
                               UPPER(RPAD(NVL(SUBSTR(NMBAIRTOMA, 1,30), ' '), 30,' ')),
                               UPPER(RPAD(NVL(SUBSTR(NMMUNICIPIO,1,50), ' '), 50,' ')),
                               RPAD(NVL(SGESTADO, ' '), 2,' '),
                               SUBSTR(LPAD(NVL(SUBSTR(REPLACE(REPLACE(NRCEPTOMA,'.',''),'-',''),1,8), '0'), 8,'0'),1,8),
                               SUBSTR(UPPER(RPAD(NVL(DSEMAILTOMA, ' '), 75,' ')),1,75),
                               SUBSTR(UPPER(SUBSTR(DSPRODEMIS,1,LENGTH(DSPRODEMIS))),1,1000),
                               NF.CDFILIAL,
                               NF.NRLANCTONF,
                               NF.VRNOTAFISC,
                               NF.NRNOTAFISC,
                               NF.CDMUNICIPIO
                      ORDER BY NRNOTAFISC)LOOP
         SELECT SUM(VRITEMENCA)
         INTO V_VRDEDUCAO
         FROM ENCARGO E, ITEMENCARGO I
         WHERE E.CDENCARGO = I.CDENCARGO
           AND VRITEMENCA > 0
           AND IDENCARGO = 'D'
           AND CDFILIAL = C_NOTAS.CDFILIAL
           AND NRLANCTONF = C_NOTAS.NRLANCTONF;

         V_DADOS := C_NOTAS.DSINICIO||RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(V_VRDEDUCAO,2), '0000000000000.00')), '.', ''),'0'), 15, '0')||C_NOTAS.DSFINAL;
         V_VRTOTAL := NVL(V_VRTOTAL,0)+NVL(C_NOTAS.VRNOTAFISC,0);
         V_VRTOTDEDUCAO := NVL(V_VRTOTDEDUCAO,0)+NVL(V_VRDEDUCAO,0);
         V_VRTOTISS := NVL(V_VRTOTISS,0)+NVL(C_NOTAS.VRTOTISS,0);
         V_VRTOTCRED := NVL(V_VRTOTCRED,0)+NVL(C_NOTAS.VRTOTCRED,0);

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('2'||LPAD(V_CONTADOR,9,'0'), V_DADOS, P_NRSEQARQMAG);

         V_CONTADOR := NVL(V_CONTADOR,0)+1;
         V_CONT_REG_2 := NVL(V_CONT_REG_2,0)+1;
         /* identificador de exportao da nf */
         UPDATE NOTAFISCAL
         SET IDEXPNFEP = 'S'
         WHERE CDFILIAL = C_NOTAS.CDFILIAL
           AND NRLANCTONF = C_NOTAS.NRLANCTONF;
      END LOOP;
   ELSE
      /* TIPO 6 */
      FOR C_NF_6 IN (SELECT '6'||
                             REPLACE(P_TPRPS,'-',' ')||
                             SUBSTR(RPAD(NVL(DECODE(IDENTRSAIDOP, 'S', CDSERIE, CDSERIEENTR),' '), 5, ' '),1,5)|| /* campo 3 */
                             SUBSTR(LPAD(NVL(NRNOTAFISC,'0'), 12, '0'),1,12)|| /* numero do rps */
                             TO_CHAR(DTEMISSAO, 'yyyymmdd')|| /* data de emissao do rps */
                             DECODE(IDSTATUS, 'C', 'C', 'T')|| /* situacao do rps */
                             SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15) AS DSINICIO,
                             LPAD(NVL(SUBSTR(CLASSE_CODTRIBPROD(CDARVPROD,P_CDEMPRESA,P_CDINSCMUNI,'SERV'),1,5),'0'),5,'0')||/* codigo do servico prestado na nf */
                             SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRALIQUOTA,2), '00.00')), '.', ''),'0'),4,'0'),1,4)|| /* valor da aliquota campo 10 */
                             '2'|| /* ISS RETIDO  campo 11 */
                             DECODE(IDTPJURTOMA, 'F', '1','2','3')||
                             SUBSTR(RPAD(REPLACE(REPLACE(REPLACE((CASE WHEN IDTPJURTOMA IN ('F','J') THEN NRINSJURTOMA ELSE '' END),'.',''),'/',''),'-',''),14,' '),1,14)|| /* campo 13 */
                             SUBSTR(LPAD(REPLACE(REPLACE(REPLACE(NRINSMUNTOMA,'/',''),'-',''),'.',''),8,'0'),1,8)|| /* inscricao municipal do tomador (fornecedor) campo 14 */
                             SUBSTR(LPAD(NVL(REPLACE(REPLACE(REPLACE(NRINSESTTOMA,'/',''),'.',''),'-',''), '0'), 12,'0'),1,12)|| /* inscricao estadual do tomador */
                             UPPER(RPAD(NVL(SUBSTR(NRRAZSOCTOMA, 1,75), ' '), 75,' '))|| /* campo 16 */
                             LPAD(' ', 3,' ')|| /* tipo de endereco do tomador */
                             UPPER(RPAD(NVL(SUBSTR(DSENDETOMA, 1,50), ' '), 50,' '))||
                             LPAD(' ', 10,' ')|| /* numero do endereco do tomador */
                             UPPER(RPAD(NVL(SUBSTR(DSCOMPLTOMA, 1,30), ' '), 30,' '))||
                             UPPER(RPAD(NVL(SUBSTR(NMBAIRTOMA, 1,30), ' '), 30,' '))||
                             UPPER(RPAD(NVL(SUBSTR(NMMUNICIPIO,1,50), ' '), 50,' '))|| /* cidade do tomador */
                             RPAD(NVL(SGESTADO, ' '), 2,' ')||  /* uf do tomador */
                             SUBSTR(LPAD(NVL(SUBSTR(REPLACE(REPLACE(NRCEPTOMA,'.',''),'-',''),1,8), '0'), 8,'0'),1,8)|| /*campo 24*/
                             SUBSTR(UPPER(RPAD(NVL(DSEMAILTOMA, ' '), 75,' ')),1,75)||  /*campo 25*/
                             SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRTOTPISRET,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15)|| /*campo 26*/
                             SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRTOTCOFINSRET,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15)|| /*campo 27*/
                             SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRTOTINSSRET,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15)|| /*campo 28*/
                             SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRTOTIRRET,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15)||  /*campo 29*/
                             SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRTOTCSLLRET,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15)|| /*campo 30*/
                             SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRTOTCRED,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15)|| /*campo 31*/
                             SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRALIQUOTA,2), '00.00')), '.', ''),'0'),4,'0'),1,4)|| /*campo 32*/
                             LPAD(' ', 10,' ')|| /*campo 33*/
                             LPAD(' ', 12,' ')|| /*campo 34*/
                             LPAD(' ', 12,' ')|| /*campo 36*/
                             LPAD(' ', 7,' ')|| /*campo 37*/
                             LPAD(' ',200,' ')|| /*campo 38*/
                             SUBSTR(UPPER(SUBSTR(DSPRODEMIS,1,LENGTH(DSPRODEMIS))),1,1000) AS DSFINAL,
                             NF.CDFILIAL, NF.NRLANCTONF, NF.VRNOTAFISC, SUM(NF.VRTOTISS) AS VRTOTISS, SUM(NF.VRTOTCRED) AS VRTOTCRED, NF.NRNOTAFISC
                      FROM (/* FORNECEDOR */
                            SELECT N.CDEMPRESA, N.CDINSCMUNI, N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC, N.NRNOTAFISC, IP.CDPRODUTO,
                                   N.IDENTRSAIDOP, N.CDSERIE, N.CDSERIEENTR, N.DTEMISSAO, N.IDSTATUS, P.CDARVPROD,
                                   VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL,N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'A') AS VRALIQUOTA,
                                   F.IDTPIJURFORN AS IDTPJURTOMA, N.NRINSJURNF AS NRINSJURTOMA, F.NRINSMUNFORN AS NRINSMUNTOMA,
                                   F.NRINSESTFORN AS NRINSESTTOMA, F.NMRAZSOCFORN AS NRRAZSOCTOMA, E.DSENDEFORN AS DSENDETOMA,
                                   E.DSCOMPENDFOR AS DSCOMPLTOMA, E.NMBAIRFORN AS NMBAIRTOMA, M.NMMUNICIPIO, E.SGESTADO,
                                   E.NRCEPFORN AS NRCEPTOMA, E.DSEMAILFORN AS DSEMAILTOMA, IP.DSPRODEMIS,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'C'),0) AS VRTOTISS,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'I'),0) AS VRTOTCRED,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_PISRETE,'I'),0) AS VRTOTPISRET,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_COFINSRETE,'I'),0) AS VRTOTCOFINSRET,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_INSSRET,'I'),0) AS VRTOTINSSRET,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_IRRFRETE,'I'),0) AS VRTOTIRRET,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_CSLLRETE,'I'),0) AS VRTOTCSLLRET
                              FROM NOTAFISCAL N, FORNECEDOR F, ENDEFORN E, MUNICIPIO M, LISTA L, ITEMPRODUTO IP, PRODUTO P
                             WHERE L.NRLISTA = P_NRLISTA
                               AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                               AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                               AND N.CDFILIAL = IP.CDFILIAL
                               AND N.NRLANCTONF = IP.NRLANCTONF
                               AND N.IDORIGDESTNF = 'F'
                               AND N.CDFORNECED = F.CDFORNECED
                               AND F.CDFORNECED = E.CDFORNECED
                               AND E.IDTPENDEFORN = 'P'
                               AND E.CDPAIS = M.CDPAIS
                               AND E.SGESTADO = M.SGESTADO
                               AND E.CDMUNICIPIO = M.CDMUNICIPIO
                               AND IP.CDPRODUTO  = P.CDPRODUTO
                            /* CLIENTE */
                            UNION ALL
                            SELECT N.CDEMPRESA, N.CDINSCMUNI, N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC, N.NRNOTAFISC, IP.CDPRODUTO,
                                   N.IDENTRSAIDOP, N.CDSERIE, N.CDSERIEENTR, N.DTEMISSAO, N.IDSTATUS, P.CDARVPROD,
                                   VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL,N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'A') AS VRALIQUOTA,
                                   C.IDTPIJURCLIE AS IDTPJURTOMA, N.NRINSJURNF AS NRINSJURTOMA, C.NRINSMUNICLIE AS NRINSMUNTOMA,
                                   C.NRINSESTCLIE AS NRINSESTTOMA, C.NMRAZSOCCLIE AS NRRAZSOCTOMA, E.DSENDECLIE AS DSENDETOMA,
                                   E.DSCOMPENDCLI AS DSCOMPLTOMA, E.NMBAIRCLIE AS NMBAIRTOMA, M.NMMUNICIPIO, E.SGESTADO,
                                   E.NRCEPCLIE AS NRCEPTOMA, E.DSEMAILCLIE AS DSEMAILTOMA, IP.DSPRODEMIS,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'C'),0) AS VRTOTISS,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'I'),0) AS VRTOTCRED,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_PISRETS,'I'),0) AS VRTOTPISRET,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_COFINSRETS,'I'),0) AS VRTOTCOFINSRET,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_INSSRET,'I'),0) AS VRTOTINSSRET,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_IRRFRETS,'I'),0) AS VRTOTIRRET,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_CSLLRETS,'I'),0) AS VRTOTCSLLRET
                              FROM NOTAFISCAL N, CLIENTE C, ENDECLIE E, MUNICIPIO M, LISTA L, ITEMPRODUTO IP, PRODUTO P
                             WHERE L.NRLISTA = P_NRLISTA
                               AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                               AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                               AND N.CDFILIAL = IP.CDFILIAL
                               AND N.NRLANCTONF = IP.NRLANCTONF
                               AND N.IDORIGDESTNF = 'C'
                               AND N.CDCLIENTE = C.CDCLIENTE
                               AND C.CDCLIENTE = E.CDCLIENTE
                               AND E.IDTPENDECLIE = 'P'
                               AND E.CDPAIS = M.CDPAIS
                               AND E.SGESTADO = M.SGESTADO
                               AND E.CDMUNICIPIO = M.CDMUNICIPIO
                               AND IP.CDPRODUTO = P.CDPRODUTO
                            /* FILIAL */
                            UNION ALL
                            SELECT N.CDEMPRESA, N.CDINSCMUNI, N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC, N.NRNOTAFISC, IP.CDPRODUTO,
                                   N.IDENTRSAIDOP, N.CDSERIE, N.CDSERIEENTR, N.DTEMISSAO, N.IDSTATUS, P.CDARVPROD,
                                   VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL,N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'A') AS VRALIQUOTA,
                                   F.IDTPIJURFILI AS IDTPJURTOMA, N.NRINSJURNF AS NRINSJURTOMA, F.CDINSCMUNI AS NRINSMUNTOMA,
                                   F.CDINSCESTA AS NRINSESTTOMA, F.NMRAZSOCFILI AS NRRAZSOCTOMA, E.DSENDEFILI AS DSENDETOMA,
                                   E.DSCOMPENDFIL AS DSCOMPLTOMA, E.NMBAIRFILI AS NMBAIRTOMA, M.NMMUNICIPIO, E.SGESTADO,
                                   E.NRCEPFILI AS NRCEPTOMA, E.DSEMAILFILI AS DSEMAILTOMA, IP.DSPRODEMIS,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'C'),0) AS VRTOTISS,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'I'),0) AS VRTOTCRED,
                                   0 AS VRTOTPISRET,
                                   0 AS VRTOTCOFINSRET,
                                   0 AS VRTOTINSSRET,
                                   0 AS VRTOTIRRET,
                                   0 AS VRTOTCSLLRET
                              FROM NOTAFISCAL N, FILIAL F, ENDEFILI E, MUNICIPIO M, LISTA L, ITEMPRODUTO IP, PRODUTO P
                             WHERE L.NRLISTA = P_NRLISTA
                               AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                               AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                               AND N.CDFILIAL = IP.CDFILIAL
                               AND N.NRLANCTONF = IP.NRLANCTONF
                               AND N.IDENTRSAIDOP = 'E'
                               AND N.IDORIGDESTNF = 'L'
                               AND N.CDFILIRECE = F.CDFILIAL
                               AND F.CDFILIAL = E.CDFILIAL
                               AND E.IDTPENDEFILI = 'P'
                               AND E.CDPAIS = M.CDPAIS
                               AND E.SGESTADO = M.SGESTADO
                               AND E.CDMUNICIPIO = M.CDMUNICIPIO
                               AND IP.CDPRODUTO = P.CDPRODUTO
                            UNION ALL
                            SELECT N.CDEMPRESA, N.CDINSCMUNI, N.CDFILIAL, N.NRLANCTONF, N.VRNOTAFISC, N.NRNOTAFISC, IP.CDPRODUTO,
                                   N.IDENTRSAIDOP, N.CDSERIE, N.CDSERIEENTR, N.DTEMISSAO, N.IDSTATUS, P.CDARVPROD,
                                   VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL,N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'A') AS VRALIQUOTA,
                                   F.IDTPIJURFILI AS IDTPJURTOMA, N.NRINSJURNF AS NRINSJURTOMA, F.CDINSCMUNI AS NRINSMUNTOMA,
                                   F.CDINSCESTA AS NRINSESTTOMA, F.NMRAZSOCFILI AS NRRAZSOCTOMA, E.DSENDEFILI AS DSENDETOMA,
                                   E.DSCOMPENDFIL AS DSCOMPLTOMA, E.NMBAIRFILI AS NMBAIRTOMA, M.NMMUNICIPIO, E.SGESTADO,
                                   E.NRCEPFILI AS NRCEPTOMA, E.DSEMAILFILI AS DSEMAILTOMA, IP.DSPRODEMIS,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'C'),0) AS VRTOTISS,
                                   NVL(VALOR_IMPOSTO_ITEM_NFE(N.CDFILIAL, N.NRLANCTONF,IP.NRSEQITPROD,V_ISS,'I'),0) AS VRTOTCRED,
                                   0 AS VRTOTPISRET,
                                   0 AS VRTOTCOFINSRET,
                                   0 AS VRTOTINSSRET,
                                   0 AS VRTOTIRRET,
                                   0 AS VRTOTCSLLRET
                              FROM NOTAFISCAL N, FILIAL F, ENDEFILI E, MUNICIPIO M, LISTA L, ITEMPRODUTO IP, PRODUTO P
                             WHERE L.NRLISTA = P_NRLISTA
                               AND SUBSTR(L.CDLISTA,1,4) = N.CDFILIAL
                               AND SUBSTR(L.CDLISTA,5,10)= N.NRLANCTONF
                               AND N.CDFILIAL = IP.CDFILIAL
                               AND N.NRLANCTONF = IP.NRLANCTONF
                               AND N.IDENTRSAIDOP = 'S'
                               AND N.IDORIGDESTNF = 'L'
                               AND N.CDFILIEMIT = F.CDFILIAL
                               AND F.CDFILIAL = E.CDFILIAL
                               AND E.IDTPENDEFILI = 'P'
                               AND E.CDPAIS = M.CDPAIS
                               AND E.SGESTADO = M.SGESTADO
                               AND E.CDMUNICIPIO = M.CDMUNICIPIO
                               AND IP.CDPRODUTO  = P.CDPRODUTO) NF
                      GROUP BY '6', REPLACE(P_TPRPS,'-',' '), SUBSTR(RPAD(NVL(DECODE(IDENTRSAIDOP, 'S', CDSERIE, CDSERIEENTR),' '), 5, ' '),1,5),
                               SUBSTR(LPAD(NVL(NRNOTAFISC,'0'), 12, '0'),1,12), TO_CHAR(DTEMISSAO, 'yyyymmdd'), DECODE(IDSTATUS, 'C', 'C', 'T'),
                               SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRNOTAFISC,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15),
                               LPAD(NVL(SUBSTR(CLASSE_CODTRIBPROD(CDARVPROD,P_CDEMPRESA,P_CDINSCMUNI,'SERV'),1,5),'0'),5,'0'),
                               SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRALIQUOTA,2), '00.00')), '.', ''),'0'),4,'0'),1,4),
                               '2',  DECODE(IDTPJURTOMA, 'F', '1','2','3'), SUBSTR(RPAD(REPLACE(REPLACE(REPLACE((CASE WHEN IDTPJURTOMA IN ('F','J') THEN NRINSJURTOMA ELSE '' END),'.',''),'/',''),'-',''),14,' '),1,14),
                               SUBSTR(LPAD(REPLACE(REPLACE(REPLACE(NRINSMUNTOMA,'/',''),'-',''),'.',''),8,'0'),1,8),
                               SUBSTR(LPAD(NVL(REPLACE(REPLACE(REPLACE(NRINSESTTOMA,'/',''),'.',''),'-',''), '0'), 12,'0'),1,12),
                               UPPER(RPAD(NVL(SUBSTR(NRRAZSOCTOMA, 1,75), ' '), 75,' ')), LPAD(' ', 3,' '),
                               UPPER(RPAD(NVL(SUBSTR(DSENDETOMA, 1,50), ' '), 50,' ')), LPAD(' ', 10,' '),
                               UPPER(RPAD(NVL(SUBSTR(DSCOMPLTOMA, 1,30), ' '), 30,' ')), UPPER(RPAD(NVL(SUBSTR(NMBAIRTOMA, 1,30), ' '), 30,' ')),
                               UPPER(RPAD(NVL(SUBSTR(NMMUNICIPIO,1,50), ' '), 50,' ')), RPAD(NVL(SGESTADO, ' '), 2,' '),
                               SUBSTR(LPAD(NVL(SUBSTR(REPLACE(REPLACE(NRCEPTOMA,'.',''),'-',''),1,8), '0'), 8,'0'),1,8),
                               SUBSTR(UPPER(RPAD(NVL(DSEMAILTOMA, ' '), 75,' ')),1,75),
                               SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRTOTPISRET,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15),
                               SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRTOTCOFINSRET,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15),
                               SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRTOTINSSRET,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15),
                               SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRTOTIRRET,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15),
                               SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRTOTCSLLRET,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15),
                               SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRTOTCRED,2), '0000000000000.00')), '.', ''),'00'),15,'0'),1,15),
                               SUBSTR(RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(VRALIQUOTA,2), '00.00')), '.', ''),'0'),4,'0'),1,4),
                               SUBSTR(UPPER(SUBSTR(DSPRODEMIS,1,LENGTH(DSPRODEMIS))),1,1000),
                               NF.CDFILIAL, NF.NRLANCTONF, NF.VRNOTAFISC, NF.NRNOTAFISC
                      ORDER BY NRNOTAFISC )LOOP
         SELECT SUM(VRITEMENCA)
         INTO V_VRDEDUCAO
         FROM ENCARGO E, ITEMENCARGO I
         WHERE E.CDENCARGO = I.CDENCARGO
           AND VRITEMENCA > 0
           AND IDENCARGO = 'D'
           AND CDFILIAL = C_NF_6.CDFILIAL
           AND NRLANCTONF = C_NF_6.NRLANCTONF;

         V_DADOS := C_NF_6.DSINICIO||RPAD(NVL(REPLACE(LTRIM(TO_CHAR(ROUND(V_VRDEDUCAO,2), '0000000000000.00')), '.', ''),'0'), 15, '0')||C_NF_6.DSFINAL;
         V_VRTOTAL := NVL(V_VRTOTAL,0)+NVL(C_NF_6.VRNOTAFISC,0);
         V_VRTOTDEDUCAO := NVL(V_VRTOTDEDUCAO,0)+NVL(V_VRDEDUCAO,0);
         V_VRTOTISS := NVL(V_VRTOTISS,0)+NVL(C_NF_6.VRTOTISS,0);
         V_VRTOTCRED := NVL(V_VRTOTCRED,0)+NVL(C_NF_6.VRTOTCRED,0);

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('2'||LPAD(V_CONTADOR,9,'0'), V_DADOS, P_NRSEQARQMAG);

         V_CONTADOR := NVL(V_CONTADOR,0)+1;
         V_CONT_REG_2 := NVL(V_CONT_REG_2,0)+1;
         /* identificador de exportao da nf */
         UPDATE NOTAFISCAL
         SET IDEXPNFEP = 'S'
         WHERE CDFILIAL = C_NF_6.CDFILIAL
           AND NRLANCTONF = C_NF_6.NRLANCTONF;
      END LOOP;
   END IF;
   V_DADOS_9 := '9'||
                LPAD(NVL(V_CONT_REG_2,0), 7, '0')||
                NVL(REPLACE(LTRIM(TO_CHAR(ROUND(V_VRTOTAL,2), '0000000000000.00')), '.', ''),'0')||
                NVL(REPLACE(LTRIM(TO_CHAR(ROUND(V_VRTOTDEDUCAO,2), '0000000000000.00')), '.', ''),'0');/*||
                NVL(REPLACE(LTRIM(TO_CHAR(ROUND(V_VRTOTISS,2), '0000000000000.00')), '.', ''),'0')||
                NVL(REPLACE(LTRIM(TO_CHAR(ROUND(V_VRTOTCRED,2), '0000000000000.00')), '.', ''),'0'); */
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('9'||LPAD(V_CONTADOR,9,'0'), V_DADOS_9 , P_NRSEQARQMAG);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('NOTAFISCAL_NFE_PAULISTANA','6.05.xxx'); END;
/
