const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const centralizadaPage = require('../../../page-objects/parametrizacao/documentos fiscais/parametrizacaoFiscalCentralizada.po.js');
const j = require('../../../json/leitorJson.po.js');
const protractorHelper = require('protractor-helper');

const parametrizacaoGridId = '72612081725106691782608';
describe('Tela Parametrização Fiscal Centralizada', () => {
	beforeAll(() => {
		loginPage.login(j.getValor('login'), j.getValor('senha'));
		geral.abrir(['Parametrização', 'Documentos Fiscais',
			'Parametrização Fiscal Centralizada']);
		z.component.footer.clickRightActionByLabel('Filtrar', true);
	});

	afterAll(() => {
		geral.sair();
	});

	it('Deve acessar a tela Parametrização Fiscal Centralizada', () => {
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${parametrizacaoGridId}`)));

		expect(z.component.header.getTitle())
			.toBe('Parametrização Fiscal Centralizada');
	});

	it('Adicionar uma regra fiscal', () => {
		geral.clickAdicionar();
		centralizadaPage.adicionarRegraFiscal(j.getValor('regraFiscal'), j.getValor('agrupamentoImpostos'),
			j.getValor('validadeInicial'), 'Utiliza', j.getValor('observacao'));
		geral.clickSalvar();
		protractorHelper.waitForElementVisibility(element(by.id(`grid-${parametrizacaoGridId}`)));
		geral.filterIt(j.getValor('regraFiscal'));

		expect(geral.gridHasText(parametrizacaoGridId, j.getValor('regraFiscal'), 1))
			.toBe(j.getValor('regraFiscal'));
	});

	it('Editar a regra adicionada', () => {
		geral.clickGrid('CDREGRAFISC', j.getValor('regraFiscal'), parametrizacaoGridId);
		geral.clickEditar();
		centralizadaPage.editarRegraFiscal();
	});

	it('Adicionar um registro na aba Imposto, com o imposto especificado nos pré-requisitos', () => {
		geral.clickGrid('CDREGRAFISC', j.getValor('regraFiscal1'), parametrizacaoGridId);
		geral.trocarAba('Imposto');
		geral.clickAdicionar();
		element.all(by.css('.zh-floating-control .control-handle')).get(0).click();
		centralizadaPage.adicionarImposto(j.getValor('impostoNFe'), 'Não');
	});
});
